/**
 * Character.js
 */

'use strict';

let Character = function (image /* Image */, name, options) {
    window.DOM_ready.then(() => {
        const canvas = window.document.createElement('canvas');
        window.document.getElementById('Feature_detection').insertBefore(canvas, window.document.getElementById('Feature_detection').childNodes[0]);

        canvas.width = image.width;
        canvas.height = image.height;
        const context = canvas.getContext('2d');
        context.drawImage(image, 0, 0, image.width, image.height);
        context.lineWidth = 3;
        context.strokeStyle = 'blue';
        canvas.style.width = "200px";
        canvas.style.height = "200px";


        faceapi.detectSingleFace(canvas, options).withFaceLandmarks()/*.withFaceDescriptor()*/.withAgeAndGender().then(face => {
//            window.alert(name + JSON.stringify(face));
//            window.alert(JSON.stringify(face.landmarks._positions));
            context.strokeRect(Math.round(face.detection._box._x), Math.round(face.detection._box._y), Math.round(face.detection._box._width), Math.round(face.detection._box._height));
            context.font = "25px Arial";
            context.fillStyle = "red";
            context.textAlign = "center";
            context.fillText(face.gender, canvas.width / 2, canvas.height / 2);
            if (face.landmarks._positions && face.landmarks._positions.length > 0) {
                context.lineWidth = 1;
                context.strokeStyle = 'yellow';
                context.beginPath();
                context.moveTo(face.landmarks._positions[0]._x, face.landmarks._positions[0]._y);
                face.landmarks._positions.filter((position, index) => {
                    return index !== 0;
                }).forEach(position => {
                    context.lineTo(position._x, position._y);
                    context.stroke();
                    context.moveTo(position._x, position._y);
                });
            }
        });
    });
};

