/*
 * Feature_detection.js
 */

'use strict';

// DOM ready:
let DOM_ready = null;
Object.defineProperty(window, "DOM_ready", {value: new Promise(function_launched_when_DOM_is_usable => {
        DOM_ready = function_launched_when_DOM_is_usable;
    }), enumerable: false, configurable: false, writable: false});
window.document.onreadystatechange = DOM_ready;

console.log(faceapi.nets);

Promise.all([
    faceapi.nets.ageGenderNet.loadFromUri('./models'),
    faceapi.nets.faceLandmark68Net.loadFromUri('./models'),
    faceapi.nets.ssdMobilenetv1.loadFromUri('./models'),
    // Donne de moins bons résultats :
    faceapi.nets.tinyFaceDetector.loadFromUri('./models')
]).then(() => {
    const Franck = new Image();
    Franck.onload = () => {
        new Character(Franck, "img/Franck.jpg", new faceapi.TinyFaceDetectorOptions());
    };
    Franck.src = "img/Franck.jpg";

    const Joseph = new Image();
    Joseph.onload = function () {
        new Character(Joseph, "img/Joseph.jpg", new faceapi.TinyFaceDetectorOptions());
    };
    Joseph.src = "img/Joseph.jpg";

    const Lena = new Image();
    Lena.onload = function () {
        new Character(Lena, "img/Lena.jpg", new faceapi.TinyFaceDetectorOptions());
    };
    Lena.src = "img/Lena.jpg";

    const Oscar = new Image();
    Oscar.onload = function () {
        new Character(Oscar, "img/Oscar.jpg", new faceapi.TinyFaceDetectorOptions());
    };
    Oscar.src = "img/Oscar.jpg";

    const Sophie = new Image();
    Sophie.onload = function () {
        new Character(Sophie, "img/Sophie.jpg", new faceapi.TinyFaceDetectorOptions());
    };
    Sophie.src = "img/Sophie.jpg";

    const Bayrou = new Image();
    Bayrou.onload = function () {
        new Character(Bayrou, "img/Bayrou.jpg", new faceapi.SsdMobilenetv1Options());
    };
    Bayrou.src = "img/Bayrou.jpg";

    const LePen = new Image();
    LePen.onload = function () {
        new Character(LePen, "img/LePen.jpg", new faceapi.SsdMobilenetv1Options()/* new faceapi.TinyFaceDetectorOptions()*/);
    };
    LePen.src = "img/LePen.jpg";

    const Macron = new Image();
    Macron.onload = function () {
        new Character(Macron, "img/Macron.jpg", new faceapi.SsdMobilenetv1Options()/*new faceapi.TinyFaceDetectorOptions()*/);
    };
    Macron.src = "img/Macron.jpg";

    const Melanchon = new Image();
    Melanchon.onload = function () {
        new Character(Melanchon, "img/Melanchon.jpg", new faceapi.SsdMobilenetv1Options());
    };
    Melanchon.src = "img/Melanchon.jpg";

    const Philippe = new Image();
    Philippe.onload = function () {
        new Character(Philippe, "img/Philippe.jpg", new faceapi.SsdMobilenetv1Options()/*new faceapi.TinyFaceDetectorOptions()*/);
    };
    Philippe.src = "img/Philippe.jpg";
});
